/* eslint @typescript-eslint/no-var-requires: "off" */
require('cross-fetch/polyfill');

(async () => {
  let search;
  let sessionToken;
  let res;

  const {
    SearchBoxCore,
    GeocodingCore,
    AddressAutofillCore,
    SessionToken
  } = require('../dist');

  // Test SearchBoxCore in Node environment
  search = new SearchBoxCore({
    accessToken: process.env.MAPBOX_ACCESS_TOKEN
  });
  sessionToken = new SessionToken();

  res = await search.suggest('740 15th St NW', { sessionToken });
  console.log(
    'SearchBoxCore: ',
    res.suggestions[0].name + ', ' + res.suggestions[0].place_formatted
  );

  // Test GeocodingCore in Node environment
  search = new GeocodingCore({
    accessToken: process.env.MAPBOX_ACCESS_TOKEN
  });
  sessionToken = new SessionToken();

  res = await search.suggest('740 15th St NW', {
    sessionToken,
    proximity: 'ip'
  });
  console.log('GeocodingCore: ', res.features[0].properties.full_address);

  // Test AddressAutofillCore in Node environment
  search = new AddressAutofillCore({
    accessToken: process.env.MAPBOX_ACCESS_TOKEN
  });
  sessionToken = new SessionToken();

  res = await search.suggest('740 15th St NW', {
    sessionToken,
    proximity: 'ip'
  });
  console.log('AddressAutofillCore: ', res.suggestions[0].full_address);
})();
